LIBRARY IEEE;
LIBRARY MACHXO2;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE MACHXO2.ALL;

ENTITY GENDECAL IS
	PORT(
		CLK : IN STD_LOGIC;
		RST : IN STD_LOGIC;
		SOUT : OUT STD_LOGIC);
END GENDECAL;

ARCHITECTURE DESCRIPT OF GENDECAL IS
	SIGNAL QINT : STD_LOGIC_VECTOR(15 DOWNTO 0); 
	SIGNAL QINTSUIVANT : STD_LOGIC_VECTOR(15 DOWNTO 0);
	SIGNAL FEEDBACK : STD_LOGIC;
BEGIN
	LFSR : PROCESS(CLK, RST)
	BEGIN
		IF(RST='1') THEN
			QINT <= "0110001101100011";
		ELSIF(CLK='1' AND CLK'EVENT AND RST='0') THEN
			--DECALAGE A DROITE
			QINT <= QINTSUIVANT;
		END IF;
	END PROCESS LFSR;
	--CALCUL DE FEEDBACK
	FEEDBACK <= QINT(0) XOR QINT(1) XOR QINT(2) XOR QINT(6);
	--PREPARATION DECALAGE A DROITE
	QINTSUIVANT <= FEEDBACK & QINT(15 DOWNTO 1);
	--SORTIE DE QINT(0)
	SOUT <= QINT(0);
END DESCRIPT;